<?php

/**
 * Plesk 10 Password Driver
 *
 * Driver that adds functionality to change the Plesk user's mailbox password.
 * The code is derived from the Virtualmin driver for password change Plugin
 * by Martijn de Munnik.
 *
 * It only works with Plesk on the same host where Roundcube runs and requires 
 * shell access in order to execute. Configuration needed in /etc/sudoers file:
 * www-data ALL=NOPASSWD: /opt/psa/bin/mail
 *
 * @version 1.0
 * @author Vicente Monroig (Digital Disseny)
 */
function password_save($currpass, $newpass)
{
    $rcmail = rcmail::get_instance();

    $username = $_SESSION['username'];

    $username = escapeshellcmd($username);
    $newpass  = escapeshellcmd($newpass);

    $cmd = "sudo /opt/psa/bin/mail -u $username -passwd $newpass";
    exec($cmd . ' 2>&1', $output, $returnvalue);
    $stroutput = implode(" ", $output);

    if ($returnvalue == 0) {
        return PASSWORD_SUCCESS;
    }
    else {
        $dummy = implode(' ', $output);
        raise_error(array(
            'code' => 600,
            'type' => 'php',
            'file' => __FILE__, 'line' => __LINE__,
            'message' => "Password plugin: Unable to execute $cmd ($stroutput, $returnvalue)"
            ), true, false);
    }

    return PASSWORD_ERROR;
}

?>
